<?php
namespace WapplerSystems\Meilisearch\Query\Modifier;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2015 Ingo Renner <ingo@typo3.org>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use WapplerSystems\Meilisearch\Domain\Search\Query\Query;
use WapplerSystems\Meilisearch\Domain\Search\Query\QueryBuilder;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * Enables tracking of detailed statistics
 *
 * @author Ingo Renner <ingo@typo3.org>
 */
class Statistics implements Modifier
{
    /**
     * @var QueryBuilder
     */
    protected $queryBuilder;

    /**
     * Elevation constructor.
     * @param QueryBuilder|null $builder
     */
    public function __construct(QueryBuilder $builder = null)
    {
        $this->queryBuilder = $builder ?? GeneralUtility::makeInstance(QueryBuilder::class);
    }

    /**
     * Enables the query's debug mode to get more detailed information.
     *
     * @param Query $query The query to modify
     * @return Query The modified query with enabled debugging mode
     */
    public function modifyQuery(Query $query)
    {
        return $this->queryBuilder->startFrom($query)->useDebug(true)->getQuery();
    }
}
